/* MailTweak internal component - Copyright (C) 2007 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://journal.mozdev.org/mailtweak.html */
tweaks = [
"columnlock","folderhide","permapen","statusicon","tagnumber","treefont","wordcount"
]
pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak.")
accept = function () {
for each (var t in tweaks) this[t].save()
if (document.getElementById("reload").checked) {
var m = false, a = false, c = false
for each (var t in tweaks) if (this[t].changed)
m = m || this[t].reloadMail,a = a || this[t].reloadAB,c = c || this[t].reloadComp
MailTweakService.reload(m, a, c)}}
changes = function () {
var rl = false, ok = false
for each (var t in tweaks) {
var c = this[t].changed
if (c) rl = rl || this[t].reload
ok = ok || c}
with (document.getElementById("reload")) {
disabled = !ok || !rl
if (disabled) checked = false}
document.documentElement.getButton("accept").disabled = !ok}
enable = function (parent, ok) {
if (!parent.localName) return
switch (parent.localName) {
case "vbox":
case "hbox":
case "description":
case "grid":
case "columns":
case "column":
case "rows":
case "row":
break;
default: parent[ok? "removeAttribute":"setAttribute"]("disabled", "true")}
var elem = parent.firstChild
while (elem) enable(elem, ok), elem = elem.nextSibling}
listClick = function (event) {
var tgt = event.originalTarget
if (event.screenX
&& tgt.localName == "listitem"
&& event.screenX >= document.getAnonymousNodes(document.getAnonymousNodes(tgt)[0])[1].boxObject.screenX)
event.stopPropagation()
else setTimeout(listSelect, 0)}
listSelect = function (event) {
var list = document.getElementById("tweak-list")
document.getElementById("item-caption").setAttribute("label", list.selectedItem.label)
document.getElementById("item-deck").selectedIndex = list.selectedIndex
enable(document.getElementById("item-deck").selectedPanel, list.selectedItem.checked)
changes()}
onload = function () {
try {Components.classes["@mozilla.org/messenger/tagservice;1"].getService(Components.interfaces.nsIMsgTagService)}
catch (ex) {
with (document.getElementById("tagnumber")) checked = false, disabled = true}
for each (var t in tweaks) this[t].init()
with (document.getElementById("tweak-list")) {
selectedIndex = 0
addEventListener("mousedown", function (event) {listClick(event)}, true)}}
scrollKey = function (event) {
var bar = event.target
var now = Number(bar.getAttribute("curpos"))
switch (event.keyCode) {
case event.DOM_VK_LEFT:
case event.DOM_VK_DOWN:
if (now > 0) bar.setAttribute("curpos", now - Number(bar.getAttribute("increment")))
break;
case event.DOM_VK_RIGHT:
case event.DOM_VK_UP:
if (now < Number(bar.getAttribute("maxpos")))
bar.setAttribute("curpos", now + Number(bar.getAttribute("increment")))
break;
case event.DOM_VK_HOME:
bar.setAttribute("curpos", 0)
break;
case event.DOM_VK_END:
bar.setAttribute("curpos", bar.getAttribute("maxpos"))
break;}
changes()}
Tweak = {
id: "",reloadMail: false,reloadAB: false,reloadComp: false,get active () {return this._checkbox.checked},get changed () {return this._checkbox.checked != this._waschecked},get reload () {return this.reloadMail || this.reloadAB || this.reloadComp},init: function () {
this._checkbox = document.getElementById(this.id)
var ok = pref.getBoolPref(this.id)
this._checkbox.checked = ok
this._waschecked = ok},save: function () {pref.setBoolPref(this.id, this._checkbox.checked)}}
columnlock = {
__proto__: Tweak,id: "columnlock",reloadMail: true,reloadAB: true,}
folderhide = {
__proto__: Tweak,id: "folderhide",reloadMail: true,}
permapen = {
__proto__: Tweak,id: "permapen",reloadComp: true,get changed () {return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked && (
document.getElementById("permapen-face").value != pref.getCharPref("permapen.face")
|| document.getElementById("permapen-size").value != pref.getIntPref("permapen.size")
|| document.getElementById("permapen-color").color != pref.getCharPref("permapen.color")
|| document.getElementById("permapen-ground").color != pref.getCharPref("permapen.ground")
|| document.getElementById("permapen-bold").checked != pref.getBoolPref("permapen.bold")
|| document.getElementById("permapen-italic").checked != pref.getBoolPref("permapen.italic")
|| document.getElementById("permapen-underline").checked != pref.getBoolPref("permapen.underline")))},init: function () {
Tweak.init.call(this)
var flist = document.getElementById("permapen-face")
try {
var ff = Components.classes["@mozilla.org/gfx/fontenumerator;1"].getService(Components.interfaces.nsIFontEnumerator).EnumerateAllFonts({})
for each (var f in ff) if (f) flist.appendItem(f, f)} catch (ex) {}
flist.value = pref.getCharPref("permapen.face")
document.getElementById("permapen-size").value = pref.getIntPref("permapen.size")
document.getElementById("permapen-color").color = pref.getCharPref("permapen.color")
document.getElementById("permapen-ground").color = pref.getCharPref("permapen.ground")
document.getElementById("permapen-bold").checked = pref.getBoolPref("permapen.bold")
document.getElementById("permapen-italic").checked = pref.getBoolPref("permapen.italic")
document.getElementById("permapen-underline").checked = pref.getBoolPref("permapen.underline")},save: function () {
Tweak.save.call(this)
pref.setCharPref("permapen.face", document.getElementById("permapen-face").value)
pref.setIntPref("permapen.size", document.getElementById("permapen-size").value)
pref.setCharPref("permapen.color", document.getElementById("permapen-color").color)
pref.setCharPref("permapen.ground", document.getElementById("permapen-ground").color)
pref.setBoolPref("permapen.bold", document.getElementById("permapen-bold").checked)
pref.setBoolPref("permapen.italic", document.getElementById("permapen-italic").checked)
pref.setBoolPref("permapen.underline", document.getElementById("permapen-underline").checked)}}
statusicon = {
__proto__: Tweak,id: "statusicon"}
tagnumber = {
__proto__: Tweak,id: "tagnumber",reloadMail: true,_wait: null,_key: null,get changed () {
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked
&& document.getElementById("tagnumber-delay").getAttribute("curpos") != this._curposwas)},get delay () {
return 200 + Number(document.getElementById("tagnumber-delay").getAttribute("curpos")) * 100},init: function () {
Tweak.init.call(this)
this._curposwas = (pref.getIntPref("tagnumber.delay") - 200) / 100
with (document.getElementById("tagnumber-delay")) {
setAttribute("curpos", this._curposwas)
addEventListener("DOMAttrModified",function (event) {
if (event.attrName != "curpos" || event.eventPhase != 2) return
changes()},true)}},keyAction: function () {
this._wait = null
document.getElementById("tagnumber-test").value = this._key
this._key = 0},test: function (event) {
document.getElementById("tagnumber-test").value = ""
event.preventDefault()
if (!event.charCode || event.charCode < event.DOM_VK_0 || event.charCode > event.DOM_VK_9)
return
var k = event.charCode - event.DOM_VK_0, n = 19
if (this._wait) {
clearTimeout(this._wait)
this._wait = null
this._key = this._key * 10 + k
var go = this._key * 10 > n}
else {
this._key = k
var go = k == 0 || k * 10 > n}
if (go) this.keyAction()
else this._wait = setTimeout("tagnumber.keyAction()", this.delay)},save: function () {
Tweak.save.call(this)
pref.setIntPref("tagnumber.delay", this.delay)}}
treefont = {
__proto__: Tweak,id: "treefont",reloadMail: true,reloadAB: true,get changed () {
return this._checkbox.checked != this._waschecked
|| (this._checkbox.checked
&& document.getElementById("treefont-size").getAttribute("curpos") != this._curposwas)},init: function () {
Tweak.init.call(this)
var size = pref.getIntPref("treefont.size")
if (size == 0) size = parseInt(document.defaultView.getComputedStyle(document.getElementById("treefont-sample"), "").fontSize)
document.getElementById("treefont-inbox").style.fontSize = String(size) + "px"
this._curposwas = size - 6
with (document.getElementById("treefont-size")) {
setAttribute("curpos", size - 6)
addEventListener("DOMAttrModified",function (event) {
if (event.attrName != "curpos" || event.eventPhase != 2) return
document.getElementById("treefont-inbox").style.fontSize = String(Number(event.newValue) + 6) + "px !important"
changes()},true)}},save: function () {
Tweak.save.call(this)
pref.setIntPref("treefont.size",Number(document.getElementById("treefont-size").getAttribute("curpos")) + 6)}}
wordcount = {
__proto__: Tweak,id: "wordcount",reloadComp: true}
